#!/usr/bin/env python

from __future__ import with_statement
import random, re, os, datetime, hashlib, thread
try:
	import MySQLdb
except ImportError,e:
	raise ImportError("MYSQL ERROR: "+str(e))
import apsw
import warnings
from limoutil import log

warnings.filterwarnings('ignore', '^.*exists$') # ignore the warnings generated by 'create X if not exists' statements

class Model(object):
	""" The Model object is a way to create database schema incrementally.

		The goal is to allow disparate modules to require different tables, or different columns on existing tables.

		1) Create the test database.

			Clear the test database forcefully.

		>>> q=Query("drop database test; create database test; use test", dsn='test')

		2) Define the database schema.

			.database() - Ensures the database exists.
				If there was no call to .database() is made in a sequence, then the db from the dsn passed to the Model() constructor is assumed for future operations.
			.table() - Ensures the table exists.

			.col() - Ensures that the column exists.

			.data() - Ensures that some default data is in place.

			The execute() on the end will build only the pieces that are missing.

		>>> start = datetime.datetime.now()
		>>> s=Model(dsn="test")\
				.database("test")\
				.table("users")\
					.col("uid int primary key auto_increment")\
					.col("name text not null")\
					.data([1, 'anonymous'])\
					.data([2, 'jldailey'])\
				.table("groups")\
					.col("gid int primary key auto_increment")\
					.col("name text not null")\
					.data([1, 'admin'])\
				.table("roles")\
					.col("rid int primary key auto_increment")\
					.col("name text not null")\
					.data([1, 'admin'])\
				.table("group_roles")\
					.col("gid int not null")\
					.col("rid int not null")\
					.col("primary key (gid, rid)")\
					.data([1, 1])\
				.table("group_users")\
					.col("gid int not null")\
					.col("uid int not null")\
					.data([1, 2])\
				.table("user_roles")\
					.col("uid int not null")\
					.col("rid int not null")\
					.execute()

		3) Extending the existing model

			The reason to use the schema object (rather than directly modifying the db) is that you can come along later
			and extend the existing model without clobbering (or knowing much about) what already exists.

			So this example adds 2 fields to the users table.

		>>> s=Model(dsn="test")\
				.database("test")\
				.table("users")\
					.col("email varchar(128)")\
					.col("passwd varchar(32) not null default ''")\
				.execute()

		>>> Query("show create table test.users", dsn="test")[0][1]
		u"CREATE TABLE `users` (\\n  `uid` int(11) NOT NULL AUTO_INCREMENT,\\n  `name` text NOT NULL,\\n  `email` varchar(128) DEFAULT NULL,\\n  `passwd` varchar(32) NOT NULL DEFAULT '',\\n  PRIMARY KEY (`uid`)\\n) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1"

			If code in 2 separate places requires the same schema, it has no effect.

			So, adding the email column again here has no effect.

			Think of the column definitions as column requirements, ensuring that the column exists as defined.

		>>> s=Model(dsn="test")\
				.database("test")\
				.table("users")\
					.col("email varchar(128)")\
					.col("unique index uq_email (email)")\
					.col("index ix_email_uid (email, uid)")\
				.execute()
		>>> Query("show create table test.users", dsn="test")[0][1]
		u"CREATE TABLE `users` (\\n  `uid` int(11) NOT NULL AUTO_INCREMENT,\\n  `name` text NOT NULL,\\n  `email` varchar(128) DEFAULT NULL,\\n  `passwd` varchar(32) NOT NULL DEFAULT '',\\n  PRIMARY KEY (`uid`),\\n  UNIQUE KEY `uq_email` (`email`),\\n  KEY `ix_email_uid` (`email`,`uid`)\\n) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1"

		>>> s=Model(dsn="test").defaultTable("pages")\
			.column("pid int primary key auto_increment")\
			.column("url varchar(256) not null")\
			.column("name varchar(256) not null")\
			.execute()
		>>> s=Model(dsn="test").defaultTable("pages")\
			.column("pid int primary key auto_increment")\
			.column("url varchar(256) not null")\
			.column("name varchar(256) not null")\
			.execute()


		4) You can forcefully modify an existing column definition by specifying a version on the column.

			Also in this example you can see that passing the database() explicitly is not required, it can be inferred from the dsn passed to the Model() constructor.

		>>> s=Model(dsn="test")\
					.table("users")\
						.col("email varchar(256)", version=1)\
					.execute()
		>>> Query("show create table test.users", dsn="test")[0][1]
		u"CREATE TABLE `users` (\\n  `uid` int(11) NOT NULL AUTO_INCREMENT,\\n  `name` text NOT NULL,\\n  `email` varchar(256) DEFAULT NULL,\\n  `passwd` varchar(32) NOT NULL DEFAULT '',\\n  PRIMARY KEY (`uid`),\\n  UNIQUE KEY `uq_email` (`email`),\\n  KEY `ix_email_uid` (`email`,`uid`)\\n) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1"

		>>> s=Model(dsn="test")\
					.table("users")\
						.col("name varchar(64) not null", version=1)\
						.col("unique index (name)")\
						.execute()
		>>> Query("show create table test.users", dsn="test")[0][1]
		u"CREATE TABLE `users` (\\n  `uid` int(11) NOT NULL AUTO_INCREMENT,\\n  `name` varchar(64) NOT NULL,\\n  `email` varchar(256) DEFAULT NULL,\\n  `passwd` varchar(32) NOT NULL DEFAULT '',\\n  PRIMARY KEY (`uid`),\\n  UNIQUE KEY `uq_name` (`name`),\\n  UNIQUE KEY `uq_email` (`email`),\\n  KEY `ix_email_uid` (`email`,`uid`)\\n) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1"

		This test always fails.

		>>> _ms_elapsed(start)
		0

	"""

	_init = {}

	def __init__(self, dsn="default", skipExecute=False):
		self.sql = ""
		self.dsn = dsn
		self.db = {}
		self._db = None
		self._table = None
		self._table_opts = {}
		self._column = None
		self._data = {}
		self._order = {}
		self._version = {}
		if not skipExecute:
			# only update the tables the first time
			if not self._init.get(self.__class__.__name__, False):
				self.model()
				self.execute()
				self._init[self.__class__.__name__] = True

	def model(self):
		self\
			.table("schema_history")\
			.col("`table_name` varchar(128) NOT NULL")\
			.col("`column_name` varchar(128) NOT NULL")\
			.col("`column_definition` text NOT NULL")\
			.col("`version` int(11) NOT NULL")\
			.col("`entered` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP")\

	def defaultDatabase(self, name):
		""" Require that a database exists, creating if necessary. """
		if self.db.get(name, None) is None:
			self.db[name] = {}
		self._db = name
		return self
	def database(self, name):
		""" Alias for defaultDatabase() """
		return self.defaultDatabase(name)

	def defaultTable(self, name,options=None):
		""" Require that a certain table be present. Uses the most recent call to .requireDatabase to get the context for the table.
			If there is no most recent call to .requireDatabase, parse the database from the datasource definition.
			Subsequent calls to defaultColumn() can be used to ensure the table's content.
		"""
		if self._db is None:
			try:
				Query._read_cfg()
				(prot, user, password, host, port, db) = re.findall(Query._db_cfg_regex, Query._cfg[self.dsn])[0]
			except TypeError:
				raise Exception("no default database found: dsn: %s cfg: %s -> %s" % ( str(self.dsn), str(Query._cfg[self.dsn]), str(e)))
			self.defaultDatabase(db)
		if self.db[self._db].get(name, None) is None:
			self.db[self._db][name] = {}
		self._table = name
		if options is not None:
			self._table_opts[name] = options
		key = self._db
		if self._order.get(key, None) is None:
			self._order[key] = []
		self._order[key].append(self._table)
		self.log("Requiring table %s: [%s] = %s" % (name, key, name))
		return self
	def table(self, name,options=None):
		""" Alias for defaultTable() """
		return self.defaultTable(name,options)

	def defaultColumn(self, definition, version=0, skipNormalize=False):
		"""
		Require that a certain column be present.
		Uses the most recent call to .requireDatabase and .requireTable to get the context for where this column should exist.
		"""
		if not skipNormalize:
			definition = self._normalize_column_definition(definition)
		# after a column definition is normalized, it might actually turn out to be more than one column (a data column, and an index)
		if type(definition) == list:
			# if so, recursively add the column and then the index
			self.log("Column requirement is a list: %s" % ( str(definition) ) )
			for d in definition:
				self.defaultColumn(d.lower(), version=version, skipNormalize=True)
			return self
		definition = definition.lower()
		name = _getNameFromDefn(definition)
		# self.log("NAME: %s FROM: %s" % (name, definition))
		self._column = name
		if self.db[self._db][self._table].get(name, None) is None:
			self.db[self._db][self._table][name] = definition
			key = self._db+self._table
			if version > 0:
				self.log("Saving _version argument: [%s] = %s" % (key+name, version))
			self._version[key+name] = version
			if self._order.get(key, None) is None:
				self._order[key] = []
			# self.log("Appending column %s to key %s (from definition: %s)" % (name, key, definition))
			self._order[key].append((name,definition))
			self.log("Requiring column %s: [%s] = %s" % (name, key, definition))
		return self
	def column(self, d, version=0): return self.defaultColumn(d,version=version)
	def col(self, d, version=0): return self.defaultColumn(d,version=version)
	def c(self, d, version=0): return self.defaultColumn(d,version=version)

	def defaultData(self, row):
		key = self._db+self._table
		if self._data.get(key, None) is None:
			self._data[key] = [row]
		else:
			self._data[key].append(row)
		return self
	def data(self, row): return self.defaultData(row)

	@staticmethod
	def log(msg):
		if msg[-1] != '\n':
			msg += '\n'
		with open("db.log", "a+") as f:
			f.write(msg)

	def execute(self):
		for db, tables in self.db.items():
			FastQuery("create database if not exists %s" % db, dsn=self.dsn)
			# pull out all the tables in the order they were specified
			for table_name in self._order[db]:
				columns = self.db[db][table_name]
				FastQuery("create table if not exists %s.%s ( __filler__ int null ) %s" %
						(db, table_name, self._table_opts.get(table_name,'')), dsn=self.dsn)
				table = _TableInfo(db+"."+table_name, dsn=self.dsn)
				assert len(table.lines.keys()) > 0
				key = db+table_name
				skipPKLater = False
				# pull out all the column in the order they were specified
				for (column_name, column_definition) in self._order.get(key, []):
					# self.log("EXECUTING: '%s' from %s" % (column_name, column_definition))
					if table.names.get(unicode(column_name), False): # if the table already has this column
						if table.names[unicode(column_name)] == column_definition: # if the existing column is identical
							# do nothing
							# self.log("COLUMN ALREADY EXISTS: %s as %s" % (column_name, column_definition))
							continue
						# retrieve the version specified for this column update
						version = self._version.get(db+table_name+column_name, None)
						self.log('DETECTED VERSION CHANGE [%s] \'%s\' :: %s != %s (version:%s)' % (table_name+"."+column_name, unicode(column_name), table.names[unicode(column_name)], column_definition, version))
						# if none was specified then we cant do versioning, so bail
						if version is None or version == 0:
							e = ModelConflictError("%s already defined as %s, and no new version number was specified" % (column_definition, table.names[unicode(column_name)]))
							# self.log('SCHEMA CONFLICT ERROR: %s' % str(e))
							raise e
						# get the current version of the column as it is on the table
						current_definition = _TableInfo(db+"."+table_name, dsn=self.dsn).getName('primary key')
						self.log("CURRENT DEFINITION: %s" % current_definition)
						current_version = Query("select coalesce(max(version),0) from schema_history where table_name = '%s' and column_name = '%s' and column_definition = '%s'" % (table_name, column_name, current_definition), dsn=self.dsn)[0][0]
						current_version = int(current_version)
						# if the specified version is newer
						if version > current_version:
							# update the history
							# TODO: save version 0
							FastQuery("replace into schema_history (table_name, column_name, column_definition, version) values ('%s', '%s', '%s', %d)" \
									% (table_name, column_name, safe(column_definition), version), dsn=self.dsn)
							# and then modify the existing column
							if column_definition.startswith("primary key"):
								FastQuery("alter table %s.%s drop primary key" % (db, table_name))
								FastQuery("alter table %s.%s add %s" % (db, table_name, column_definition))
							else:
								FastQuery("alter table %s.%s modify %s" % (db, table_name, column_definition), dsn=self.dsn)
						else:
							# skip obsolete column definition
							continue
					else:
						# self.log("COLUMN DID NOT PREVIOUSLY EXIST: %s in %s" % (column_definition, str(table.names.keys())))
						# the column didnt exist so just add it
						# HACK: to fix bug with primary key columns
						if skipPKLater and column_definition.find("primary key") > -1:
							skipPKLater = False
							continue
						if column_definition.find("auto_increment") > -1:
							column_definition = column_definition.replace("auto_increment", "auto_increment primary key")
							skipPKLater = True
						try:
							FastQuery("alter table %s.%s add %s" % (db, table_name, column_definition), dsn=self.dsn)
						except Exception, e:
							self.log("FAILED: %s (sql: %s)" % ( str(e), "alter table %s.%s add %s" % (db, table_name, column_definition)))
							raise
				if table.names.get("__filler__", False):
					FastQuery("alter table %s.%s drop __filler__" % (db, table_name))
				if self._data.get(key, None) is not None:
					data = self._data[key]
					self.log("Key: %s has required data: %s" % (key, str(data)))
					table = _TableInfo(db+"."+table_name, dsn=self.dsn) # reload the table definition
					for row in data:
						cols = ', '.join([c for c in table.order[0:len(row)] if c != 'primary key'])
						for r in range(len(row)):
							if row[r] is None:
								row[r] = "NULL"
						values = ', '.join(["'%s'"%s for s in row])
						FastQuery("insert ignore into %s ( %s ) values ( %s )" % (table_name, cols, values), dsn=self.dsn)
					del self._data[key]

	def _normalize_column_definition(self, defn):
		'''

		This creates an empty 'probe' table in the database with just the necessary columns.
		Then calls 'show table' to get the server to produce the standard version of that sql.


		>>> Model()._normalize_column_definition('email varchar(32)')
		u'`email` varchar(32) default null'

			If a single line column definition actually results in more than one column on the resulting table, a list of columns is returned.

		>>> Model()._normalize_column_definition('uid int primary key auto_increment')
		[u'`uid` int(11) not null auto_increment', u'primary key (`uid`)']

		>>> Model()._normalize_column_definition('primary key (id, name)')
		u'primary key (`id`,`name`)'

		>>> Model()._normalize_column_definition('unique index (vid, url(32), sid)')
		u'unique key `uq_vid_url_sid` (`vid`,`url`(32),`sid`)'

		'''
		# self.log("_normalize_column_definition(%s)" % defn)
		t = 'probe_table_%d' % random.randrange(0,9999999)
		defn = defn.lower()
		try:
			columns = [ x.strip() for x in defn[defn.find('(')+1:defn.rfind(')')].split(',') ]
		except IndexError:
			columns = []
		ret = []
		is_compound_pk = (re.search('\S\sprimary key', defn) is not None)
		if re.search("(?:index|key)\s*\(", defn) is not None:
			prefix = "ix_"
			if defn.find("unique") > -1:
				prefix = "uq_"
			name = prefix + "_".join([ re.sub("\(\d+\)","",x) for x in columns ]).replace("`","").replace("'","")
			defn = re.sub("(?:index|key)", "key `%s`" % name, defn)
		# if its a simple index column, then the probe table needs the indexed columns to be built
		if _match_any(defn, ('unique ', 'key ', 'index ', 'fulltext ')) and not is_compound_pk:
			if _match_any(defn, ('fulltext',)):
				type = "text"
			else:
				type = "integer"
			for col in columns:
				col = col.replace(" ","")
				# if the column being indexed specified a prefix, then it must refer to a varchar field that is long enough
				save_type = type
				open = col.find('(')
				if open > -1:
					close = col.rfind(')')
					# build the new type with a long enough varchar
					type = "varchar(%d)" % (int(col[open+1:close]) + 1)
					# set the column name to be the name without the prefix
					col = col[0:open]
				# prepend this to the existing list of columns
				defn = "%s %s, %s "%(col, type, defn)
				type = save_type
		# create the probe table
		Query("create table %s ( %s )" % (t, defn))
		# read back the table definition
		table = _TableInfo(t)
		Query("drop table %s" % t)
		# pull out just the column text
		for name in table.order:
			line = table.names[name]
			if name not in columns: # dont return columns that were generated to satisfy an index
				ret.append(line)
				# self.log("ADDING COLUMN: %s from %s not in %s" % (name, line, str(columns)))
			# else:
				# self.log("INGORING COLUMN: %s from %s in %s" % (name, line, str(columns)))
		if is_compound_pk:
			ret = [r.strip().lower() for r in ret]
		else:
			ret = ret[-1].strip().lower()
		return ret


	@staticmethod
	def int_uid(from_string):
		return Model.uid(from_string).__hash__()
	@staticmethod
	def uid(from_string):
		return hashlib.sha1(from_string).hexdigest()

class Query(object):
	"""
		A good non-dbapi db system should:

		Gets its configuration from a db.cfg file, no connect params in code

		db.cfg:
		default="mysql://user:password@localhost/db1"
		foo="mysql://user:password@localhost/foo"

		1) Allow direct, named, query access:

		>>> result = Query("select * from users where 1 = 0",dsn="test")
		>>> type(result)
		<class '__main__.Query'>
		>>> len(result)
		0

		2) Support iteration:

		>>> for row in Query("select * from users",dsn="test"):
		...		print "uid: %d name: %s rowIndex: %d" % (int(row.uid), row.name, row.rowIndex)
		uid: 1 name: anonymous rowIndex: 0
		uid: 2 name: jldailey rowIndex: 1

		3) Allow indexed access by columns in a wide variety of ways:

		>>> result = Query("select uid, name from users",dsn="test")
		>>> result[0].name
		u'anonymous'
		>>> result[0]['name']
		u'anonymous'

		3a) Using the name as the first indexor creates a projection of the data, and further indexers pull rows from that projection

		>>> result['name'][0]
		u'anonymous'
		>>> result.name[0]
		u'anonymous'

		3b) Using the name as an attribute selects a single column

		>>> result[1]['name']
		u'jldailey'
		>>> result[1].name
		u'jldailey'

		3c) You can see any individual Row object in its entirety

		>>> type(result[0])
		<class '__main__.Row'>

		3d) You can pull out multi-dimensional projections of the data using comma-separated string indexes

		>>> result[0]['uid, name']
		[1L, u'anonymous']

		>>> result[0:2]['uid, name']
		[[1L, u'anonymous'], [2L, u'jldailey']]

		>>> result[0:2].uid
		[1L, 2L]

		>>> for i in result[0:2].uid:
		...		print i
		1
		2

		>>> for i in result.uid:
		...		print i
		1
		2

		>>> for i in result['uid, name']:
		...		print i
		{Row:'uid': 1L,'name': u'anonymous'}
		{Row:'uid': 2L,'name': u'jldailey'}

		>>> result['uid, name']
		(RowList:{Row:'uid': 1L,'name': u'anonymous'},{Row:'uid': 2L,'name': u'jldailey'})
		>>> result['uid, name'][0]
		{Row:'uid': 1L,'name': u'anonymous'}
		>>> result['uid, name'][0:1]
		(RowList:{Row:'uid': 1L,'name': u'anonymous'})
		>>> result['uid, name'][0:2]
		(RowList:{Row:'uid': 1L,'name': u'anonymous'},{Row:'uid': 2L,'name': u'jldailey'})

		NOTE: The critical difference is whether you use names first: names select columns, numbers select rows.
		If you select rows first, it returns you just the raw data in a tuple
		If you select the columns first, it returns you real row objects

		4) Allow query of queries

		First do something to pull back a data set

		>>> result = Query('''\
			select u.name as user_name, r.name as role_name from users u\
			left join user_roles ur on ur.uid = u.uid\
			left join roles r on ur.rid = r.rid\
			union\
			select u.name as user_name, r.name as role_name from users u\
			left join group_users gu on gu.uid = u.uid\
			left join groups g on gu.gid = g.gid\
			left join group_roles gr on gr.gid = g.gid\
			left join roles r on r.rid = gr.rid\
			''',dsn="test")
		>>> len(result)
		3
		>>> result[0:3]
		(RowList:{Row:'user_name': u'anonymous','role_name': u'None'},{Row:'user_name': u'jldailey','role_name': u'None'},{Row:'user_name': u'jldailey','role_name': u'admin'})

		Then execute queries against that resultset.

		>>> result2 = result.Query("select distinct role_name from __self__")
		>>> type(result2)
		<class '__main__.Query'>
		>>> len(result2)
		2
		>>> result2[0:2]
		(RowList:u'None',u'admin')

		>>> for i in result2:
		...		print i
		{Row:'role_name': u'None'}
		{Row:'role_name': u'admin'}

		>>> assert(u'admin' == result2[1].role_name)
		>>> assert(u'None' == result2[0].role_name)

		>>> count = result.Query("select count( distinct role_name ) from __self__")
		>>> count[0][0]
		u'2'
		>>> count = result.Query("select count( distinct role_name ) as qty from __self__")

		4a) All sub-queries support the same operations as real queries, except they lose type information (a temporary limitation of using pysqlite2 instead of 3, waiting for sqlite3/python2.5 to be fixed)
				Everything that comes out of a sub-query will be a unicode string

		>>> count[0].qty
		u'2'

		>>> int(count[0].qty)
		2

		4b) Query of queries can join 2 result sets together

		>>> get_users = Query(name="get_users", sql="select * from users",dsn="test")
		>>> get_groups = Query(name="get_groups", sql="select * from group_users",dsn="test")
		>>> result = get_users.Query("select u.uid, u.name, r.gid from get_users u join get_groups r on r.uid = u.uid")
		>>> result[0]
		{Row:'uid': u'2','name': u'jldailey','gid': u'1'}

		If you dont want to specify a name for the query, you can use the special token: __self__ in the query.
		The __self__ token will be replaced by the name of the parent query.
		You can also access a queries _name property to get the name of the backing table directly.
		(If you dont specify a name, this will be an autogenerated value like: 'autoname_<40 character sha1 hash>')

		>>> get_users = Query("select * from users", dsn="test")
		>>> get_groups = Query("select * from group_users",dsn="test")
		>>> result = get_users.Query("select u.uid, u.name, r.gid from __self__ u join %s r on r.uid = u.uid" % get_groups._name)
		>>> result[0]
		{Row:'uid': u'2','name': u'jldailey','gid': u'1'}

		5) Get a log of all queries executed:
		>>> for (sql, duration) in Query.getQueryLog():
		...		pass # dont verify the output, since there is too much of it

		5a) Clear the log of query data.

		>>> Query.clearQueryLog()

	"""

	_db = {}
	_sqlite = {}
	_cfg = None
	_cfg_mtime = 0
	_cache = {}
	_db_cfg_regex = '(mysql)://(\w+):(\w*)@([^:]+):(\d+)/(\w+)'
	@staticmethod
	def _init_cfg():
		if Query._cfg is None:
			Query._read_cfg()
	@staticmethod
	def _read_cfg():
		# read the cfg if modified
		db_cfg = os.path.sep.join(__file__.split(os.path.sep)[:-1] + ["db.cfg"])
		m = os.path.getmtime( db_cfg )
		if m > Query._cfg_mtime:
			Query._cfg_mtime = m
			s = open(db_cfg).read()
			Query._cfg = {}
			for p in [p.split('=') for p in s.replace('\r','').split('\n') if len(p) > 0]:
				Query._cfg[p[0]] = p[1]
				if Query._db.get(p[0], None) is not None:
					Query._db[p[0]].close()
				Query._db[p[0]] = None
	@staticmethod
	def _update_connections(dsn):
		""" Connect to the sqlite results datasource, and make sure that we have a mysql connection.
		Returns the mysql connection.
		"""
		tid = thread.get_ident()
		if Query._sqlite.get(tid, None) is None:
			Query._sqlite[tid] = apsw.Connection(":memory:")
		if Query._db.get(tid,None) is None:
			Query._db[tid] = {}
		Query._read_cfg()
		if Query._db[tid].get(dsn,None) is None: # instantiate the needed connections
			try:
				(prot, user, password, host, port, db) = re.findall(Query._db_cfg_regex, Query._cfg[dsn])[0]
				port = int(port)
			except KeyError:
				raise Exception("DSN argument passed to Query (dsn='%s') was not found in the cfg (available: '%s')" % (db, str(Query._cfg.keys())))
			except ValueError:
				raise ValueError("DSN specified in db.cfg has non-integer port value: '%s'" % port)

			try:
				log("FastQuery: Connecting to db... %s %s %s" % (host,db,user))
				Query._db[tid][dsn] = MySQLdb.connect(host=host, port=port, db=db, user=user, passwd=password)
				log("FastQuery: Connected...")
			except MySQLdb.OperationalError:
				# try re-connecting without specifying the database
				Query._db[tid][dsn] = MySQLdb.connect(host=host, user=user, passwd=password)
				# then create it and connect to the empty db
				Query._db[tid][dsn].cursor().execute("create database if not exists %s" % db)
				Query._db[tid][dsn].close()
				Query._db[tid][dsn] = MySQLdb.connect(host=host, db=db, user=user, passwd=password)
		return Query._db[tid][dsn]

	@staticmethod
	def _close_connection(dsn):
		tid = thread.get_ident()
		cxt = Query._db.get(tid,{}).get(dsn,None)
		if cxt is not None:
			cxt.close()
			Query._db[tid][dsn] = None

	def __init__(self, sql=None, name=None, dsn="default", cursor=None, cache=False):
		""" Query -
			Can be instantiated in 2 ways: with a sql string, which will be executed against the remote data source
			Or, with a cursor object that is already full of results. (.description and .fetchall() must work)
		"""
		if name is None:
			if sql is not None:
				name = "autoname_%s" % hashlib.sha1(sql).hexdigest()
			else:
				name = "autoname_%s" % hashlib.sha1(str(random.randrange(0,99999999))).hexdigest()
		self._name = name
		self.dsn = dsn
		self.currentRow = -1
		self.rowCount = 0
		# if we were called with just sql, this means we want to run statements directly on the real back end
		if sql is not None and cursor is None:
			self.sql = sql
			if cache and Query._cache.get(sql, None) is not None:
				start = datetime.datetime.now()
				(other_name, self.columns, self.rowCount) = Query._cache[sql]
				if self._name.startswith('autoname'):
					# since the caller didnt specify a name, they dont care what the name is, so we can share a backing table with the cached data
					self._name = other_name
				else:
					# since we are giving this data a new name, it needs a new backing table, in case we need to join against it
					# TODO: a dict full of redirections would serve? Difficulty: any number of autoname queries could reference the same backing table, but once that table gets a real name, you have to start copying, because someone could issue an update statement on it, and change other result sets.
					c = Query._sqlite_cursor()
					c.setexectrace(self.log_sqlite)
					c.execute("create table %s as select * from %s" % (self._name, other_name))
				Query.logQuery("CACHED: "+sql, _ms_elapsed(start))
				return
			# read the cfg file if it has changed
			Query._read_cfg()
			# get a db connection
			self.db = Query._update_connections(dsn)
			# start a timer
			start = datetime.datetime.now()
			try:
				# run the query
				c = self.db.cursor()
				c.execute(sql)
			except Exception, e:
				if e[0] == 2006:
					self.log("LOST CONNECTION TO DB: RECONNECTING...")
					Query._close_connection(self.dsn)
					self.db = Query._update_connections(self.dsn)
					c = self.db.cursor()
					c.execute(sql)
				else:
					raise SQLException(str(e), sql)
			Query.__init__(self, sql=sql, name=self._name, cursor=c)
			# log the query
			Query.logQuery(sql, _ms_elapsed(start))
		elif cursor is not None: # otherwise, we are loading the raw way, using the result of some other query
			if sql is not None:
				self.sql = sql
			try:
				self.columns = cursor.description
				self.rows = cursor.fetchall()
			except AttributeError:
				self.rows = []
				try:
					self.columns = cursor.getdescription()
					for row in cursor:
						self.rows.append(Row(cursor, row, index=len(self.rows)))
				except apsw.ExecutionCompleteError:
					self.columns = []
			self.rowCount = len(self.rows)
			c = Query._sqlite_cursor()
			c.setexectrace(self.log_sqlite)
			if self.columns is not None and len(self.columns) > 0:
				create = "create table %s ( %s )" % (self._name, ','.join(["[%s] %s"%(x[0], self._get_sqlite_typename(x[1])) for x in self.columns]))
				try:
					c.execute(create)
				except apsw.SchemaChangeError, e: # some version of apsw raise SchemaChangeError, some versions raise SQLError, so we have to catch both
					s = str(e)
					if s.endswith('already exists'):
						pass
					else:
						raise
				except apsw.SQLError, e:
					s = str(e)
					if s.endswith('already exists'):
						pass
					else:
						raise
				if len(self.rows) > 0:
					max_rows_per = 499
					num_inserts = int(len(self.rows)/max_rows_per) + 1
					for n in range(num_inserts):
						a = n*max_rows_per
						b = min(len(self.rows),(n+1)*max_rows_per)
						insert = u"insert or ignore into %s ( %s ) %s" % (
								self._name,
								u','.join([u"[%s]"%x[0] for x in self.columns]),
								u' union all '.join([u'select '+u','.join([u"%s" % self._sqlrepr(s) for s in row]) for row in self.rows[a:b]]))
						try:
							c.execute(insert)
						except Exception, e:
							raise Exception("FAILED INSERT: (a: %s, b: %s len(self.rows[a:b]): %s)" % (a,b,len(self.rows[a:b])))
			if sql.lower().startswith('select'):
				Query._cache[sql] = (self._name, self.columns, self.rowCount)

	def __del__(self):
		c = Query._sqlite_cursor()
		c.setexectrace(self.log_sqlite)
		self.log_sqlite("IN __DEL__", None)
		c.execute("drop table if exists %s" % self._name)

	@staticmethod
	def logQuery(sql, duration):
		Query.log("[%.2f] %s" % (duration, sql))
		if Query._sqlite is None: return
		# prepare the query log
		c2 = Query._sqlite_cursor()
		c2.execute(u"create table if not exists query_log ( sql text not null, duration int )");
		sql = sql.replace("'","''")
		c2.execute("insert into query_log ( sql, duration ) values ( '%s', %f )" % (sql, duration))

	@staticmethod
	def getQueryLog():
		if Query._sqlite is None: return
		c2 = Query._sqlite_cursor()
		c2.execute("select sql, duration from query_log order by rowid asc")
		for (sql, duration) in c2:
			yield (sql, duration)

	@staticmethod
	def clearQueryLog():
		try:
			c2 = Query._sqlite_cursor()
			c2.execute("delete from query_log")
		except Exception, e:
			raise e

	def _sqlrepr(self, o):
		if type(o) == int:
			return unicode(o)
		else:
			return u"'%s'" % str(o).decode('iso-8859-2').replace("'","''")

	def _get_sqlite_typename(self, t):
		if t == MySQLdb.NUMBER:
			return "integer"
		else:
			return "text"

	@staticmethod
	def _update_sqlite():
		tid = thread.get_ident()
		if Query._sqlite[tid] is None:
			Query._sqlite[tid] = apsw.Connection(":memory:")
	@staticmethod
	def _sqlite_cursor():
		tid = thread.get_ident()
		return Query._sqlite[tid].cursor()

	def Query(self, sql=None, name=None):
		"""
		Returns a new Query that selects from this result set as if it were a table.
		- Can join to other resultsets by name.
		"""
		c = Query._sqlite_cursor()
		c.setexectrace(self.log_sqlite)
		sql = sql.replace("__self__", self._name)
		c.execute(sql)
		return Query(name=name, sql=sql, cursor=c)

	def __len__(self):
		return self.rowCount

	def __getitem__(self, key):
		if isinstance(key, slice):
			i = key.indices(len(self))
			return self._rows("*", range(i[0],i[1],i[2]))
		elif isinstance(key, str):
			return self._rows(key, range(0,len(self)))
		elif isinstance(key, int):
			return self._rows("*", [key], single=True)
		else:
			raise ArgumentError("Unknown type: "+str(type(key)))

	def __getattribute__(self, name):
		try:
			return object.__getattribute__(self, name)
		except AttributeError:
			try:
				return self._rows(name, range(0,object.__getattribute__(self, "rowCount")))
			except apsw.SQLError, e:
				raise AttributeError(name)

	def _rows(self, columns, keys, single=False, rowIndex=-1):
		c = Query._sqlite_cursor()
		c.setexectrace(self.log_sqlite)
		ret = []
		try:
			for row in c.execute("select %s from %s where (rowid-1) in (%s)" % (columns, self._name, ','.join([str(x) for x in keys]))):
				ret.append(Row(c,row, index=len(ret)))
		except apsw.SQLError, e:
			raise #apsw.SQLError("SQLite error.  Original query that generated sqlitetable: %s  SQLite error: %s" % (str(self.sql), str(e)))
		if single:
			try:
				ret[0].rowIndex = rowIndex
				return ret[0]
			except IndexError:
				raise IndexError("columns: %s keys: %s expected a result and got none" % (columns, keys))
		else:
			# r = RowList(ret)
			# assert(len(r) == len(ret))
			# return r
			return RowList(ret)

	def __iter__(self):
		return self

	def next(self):
		self.currentRow += 1
		if self.currentRow >= self.rowCount:
			self.currentRow = -1
			raise StopIteration
		return self._rows("*",[self.currentRow, ], single=True, rowIndex=self.currentRow)

	def __repr__(self):
		return "{Query: %s backed by table: %s}" % (self.sql, self._name)

	def __str__(self):
		return str(self[0:len(self)])

	def log_sqlite(self, sql, bindings,unknown=None):
		# self.log("SQLITE: "+sql+" BINDINGS: "+str(bindings))
		return True

	@staticmethod
	def log(msg):
		if msg[-1] != '\n':
			msg += '\n'
		with open("db.log", "a+") as f:
			f.write(msg)

class RowList(object):
	def __init__(self, list):
		""" Takes a list of Row objects """
		self.__list = []
		for i in list:
			if i.columncount() == 1:
				self.__list.append(i[0])
			else:
				self.__list.append(i)
		assert(len(self.__list) == len(list))
	def __getitem__(self, key):
		if isinstance(key, int):
			return self.__list[key]
		elif isinstance(key, slice):
			return RowList(self.__list[key])
		else:
			ret = [i.__getitem__(key) for i in self.__list]
			return ret
	def __getattribute__(self, key):
		try:
			return object.__getattribute__(self, key)
		except AttributeError:
			return [i.__getattribute__(key) for i in self.__list]
	def __repr__(self):
		return self.__str__()
	def __str__(self):
		return "(RowList:"+','.join([repr(x) for x in self.__list])+")"
	def __len__(self):
		return len(self.__list)
	def __iter__(self):
		return self.__list.__iter__()

class Row(object):
	def __init__(self, cursor, row, index=None):
		self.rowIndex = index
		self.__c = []
		self.__t = []
		for col in cursor.getdescription():
			self.__c.append(col[0])
			self.__t.append(col[1])
		self.__d = [(d if d is not None else 0) for d in row]
	def columncount(self):
		return len(self.__c)
	def column(self, i):
		return self.__c[i]
	def __repr__(self):
		return self.__str__()
	def __str__(self):
		return "{Row:"+','.join(["'%s': %s" % (self.__c[i],repr(self.__d[i])) for i in range(0, len(self.__c))])+"}"
	def __getattribute__(self, key):
		try:
			return object.__getattribute__(self, key)
		except AttributeError:
			try:
				i = self.__c.index(key)
				return self.__d[i]
			except ValueError:
				raise AttributeError(key)
	def __getitem__(self, key):
		if isinstance(key, str):
			try:
				i = self.__c.index(key)
				return self.__d[i]
			except ValueError:
				if key.find(',') > -1:
					return [self.__getitem__(k.replace(' ','')) for k in key.split(',')]
				raise KeyError(key)
		elif isinstance(key, int):
			return self.__d[key]
		elif isinstance(key, slice):
			return self.__d[key]
	def dict(self):
		d = {}
		for i in range(0,len(self.__c)):
			col = self.__c[i]
			d[col] = self.__d[i]
		return d
	def __len__(self):
		return 1

class FastQuery(object):
	""" FastQuery is a way to shortcut all the bulky components in query that allow requerying, slicing, etc.
	Still uses dsn="..." and the db.cfg file, except it only supports iterating the results
	"""
	def __init__(self, sql, dsn="default"):
		self.sql = sql
		self.dsn = dsn
		self.c = None
		# get a db connection
		db = Query._update_connections(dsn)
		# execute the query
		self.start = datetime.datetime.now()
		self.c = db.cursor()
		try:
			self.c.execute(sql)
		except Exception, e:
			if e[0] == 2006:
				Query._close_connection(self.dsn)
				self.c = Query._update_connections(self.dsn).cursor()
				self.c.execute(sql)
			else:
				raise SQLException(str(e), sql)
		Query.logQuery("FAST: "+self.sql, _ms_elapsed(self.start))
	def __iter__(self):
		return self
	def next(self):
		row = self.c.fetchone()
		if row is None:
			raise StopIteration
		return [ (d if d is not None else 0) for d in row ]
	def __del__(self):
		self.c.close()

def _getNameFromDefn(defn):
	"""
	>>> Model()._getNameFromDefn("`email` varchar(256) not null")
	'email'

	>>> Model()._getNameFromDefn("`email` text not null")
	'email'

	>>> Model()._getNameFromDefn("primary key (`foo`)")
	'primary key'

	>>> Model()._getNameFromDefn("index `foo` (`bar`)")
	'foo'

	>>> Model()._getNameFromDefn("index (`bar`)")
	'ix_bar'

	"""
	# primary keys have a constant name
	if re.search('^\s*primary key\s*\(', defn, re.I) is not None:
		return "primary key"
	# normal columns just get the name parsed off
	ret = defn.split("`")
	try:
		return ret[1].lower()
	except IndexError, e:
		raise IndexError("%s did not split on `" % defn)

class _TableInfo:
	def __init__(self, name, dsn="default"):
		self.name = name
		self.names = {}
		self.lines = {}
		self.order = []
		self.text = ""
		try:
			self.text = Query("show create table %s" % name, dsn=dsn, cache=False)
			assert type(self.text) == Query, "Unexpected type: %s" % str(type(self.text))
			self.text = self.text[0]
			assert type(self.text) == Row, "Unexpected type: %s" % str(type(self.text))
			self.text = self.text[1]
			assert type(self.text) == unicode, "Unexpected type: %s" % str(type(self.text))
			self.text = self.text.lower()
			for line in self.text.split('\n')[1:-1]:
				name = _getNameFromDefn(line)# line.split('`')[1]
				name = re.sub( ',*\s*$', '', re.sub('^\s*','', name))
				line = re.sub( ',*\s*$', '', re.sub('^\s*','', line))
				self.names[name] = line
				self.lines[line] = name
				self.order.append(name)
		except MySQLdb.ProgrammingError:
			raise
	def getName(self, name):
		return self.names.get(name, None)
	def hasDefn(self, defn):
		return self.lines.get(defn, None)

def safe(s):
	"""
	Returns a db-injection safe copy of the given string.
	"""
	# TODO: more filters
	return re.sub("([^'])'",r"\1''", s)

class ModelConflictError(Exception):
	pass

class SQLException(Exception):
	"""
		>>> Query("this is not a valid sql statement", dsn="test") #doctest: ELLIPSIS
		Traceback (most recent call last):
			...
		SQLException: ...
	"""
	def __init__(self, msg, sql):
		Exception.__init__(self, msg)
		self.sql = sql
	def __str__(self):
		return Exception.__str__(self)+" (sql: %s)" % (self.sql)
	def __unicode__(self):
		return unicode(self.__str__())
	def __repr__(self):
		return self.__str__()

def _ms_elapsed(since):
	d = (datetime.datetime.now() - since)
	return (d.seconds *1000.0) + (d.microseconds / 1000.0)

def _match_any(s, l):
	for t in l:
		if s.find(t) > -1:
			return True

if __name__ == "__main__":
	# run the tests the hard way, to force the order
	import doctest, unittest
	suite = unittest.TestSuite()
	finder = doctest.DocTestFinder()
	tests = []
	tests.extend(finder.find(Model))
	tests.extend(finder.find(Query))
	# print str(tests)

	runner = doctest.DocTestRunner()
	for test in tests:
		runner.run(test)


